#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>

#include <err.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>
#include <unistd.h>

#include "cpu.h"

int
main(argc, argv)
	int argc;
	char *argv[];
{
	int fd;
	int ret;
	cpu_msr_args_t args = {
		.msr	= 0x01b,
	};

	cpu_cpuid_args_t args1 = {
		.level	= 1,
	};

	fd = open("/dev/cpu0", O_RDWR, 0);
	if (fd < 0)
		err(EX_NOINPUT, "open()");

	ret = ioctl(fd, CPU_RDMSR, &args);
	if (ret < 0)
		err(EX_IOERR, "ioctl");

	fprintf(stderr, "%#.16llx\n", args.data);

	ret = ioctl(fd, CPU_CPUID, &args1);
	if (ret < 0)
		err(EX_IOERR, "ioctl");

	fprintf(stderr, "%#.8x %#.8x %#.8x %#.8x\n", args1.data[0], \
		args1.data[1], args1.data[2], args1.data[3]);

	return 0;
}
