#!/usr/bin/env ruby

begin

micro = nil

$stdin.each do |line|
  if line =~ /\/\*[[:space:]]+([^\.]+)\.inc[[:space:]]+\*\// then
    micro.close unless micro.nil?
    micro = File.new($1 + ".fw", File::CREAT|File::TRUNC|File::RDWR, 0644)
  end
  next if line =~ /^\//
  i = line.split(/,[[:space:]]*/).collect { |number| number.to_i(0)}
  micro.write(i.pack("IIII"))
end

rescue SystemCallError
unless micro.nil?
  micro.close
  File.delete(ARGV[0])
end
  raise

ensure
  micro.close unless micro.nil?
end
